/*
 * for check routine
 */

#include <stdio.h>
#include <fcntl.h>

extern int debug;

void
dump_to_file(char *filename, char *image, int size)
{
    int fd;

    if ( (fd = open(filename, (O_WRONLY|O_CREAT|O_TRUNC), 0644)) < 0 ) {
        fprintf(stderr, "dump_to_file: cannot open %s:", filename);
        perror("open");
    }
    write(fd, image, size);
    close(fd);

    if (debug>=100)
        fprintf(stderr, "dump_to_file: imagePtr# %x\n", image);
}

void
dump_rgb_to_file(char *filename, char *image, int wid, int ht)
{
    int fd;
    char head[64];
    int nw;

    if ( (fd = open(filename, (O_WRONLY|O_CREAT|O_TRUNC), 0644)) < 0 ) {
        fprintf(stderr, "dump_rgb_to_file: cannot open %s:", filename);
        perror("open");
    }
    sprintf(head,"P6 %d %d %d\n", wid, ht, 255);
    nw = write(fd, head, strlen(head));
    nw = write(fd, image, wid*ht*3);
    close(fd);

    if (debug>=100)
        fprintf(stderr, "dump_rgb_to_file: imagePtr# %x\n", image);
}
