
/*
 * shared memory procedures
 *     
 * $Id: shm.c, 2000-06-26(Mon) 12:31:27 satosi-f $
 */

#include <stdio.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>

#include <errno.h>

#if 0
#include "shm.h"

key_t   sentry_shmkey = SENTRY_SHMKEY;
int     sentry_shm_chunk_radix = SENTRY_SHM_CHUNK_RADIX;
int     sentry_shmid;
sentry_shmrec   *sentry_shm_chunk;
sentry_shmrec   *sentry_shm_info;
#endif


int make_new_pool(key_t shmkey, size_t pool_size)
{
  int chk;
  int flg;

  flg = 0666;
  flg = flg | IPC_CREAT;

  chk = shmget(shmkey, (int)pool_size, flg);
  if (chk < 0) {
    fprintf(stderr, "errno = %d; for key %d, size %d %dKB, flg %d\n",
        errno, shmkey, pool_size, pool_size/1024, flg);
    perror("make_new_pool: fail shmget()");
    return chk;
  } 

  return chk;
}    

int delete_pool(int shmid)
{
  int chk;

  chk = shmctl(shmid, IPC_RMID, NULL);

  return chk;
}

int assign_pool(key_t shmkey)
{
  int chk;
  int flg;

  flg = 0666;
  
  chk = shmget(shmkey, (int)0, flg);
  if (chk < 0) {
    perror("assign_pool: fail shmget()");
    return chk;
  }

  return chk;
}

int show_pool_stat(int shmid)
{
  struct shmid_ds act_buf, *buf;
  int chk;

  buf = &act_buf;

  fprintf(stdout, "====\n");
  fprintf(stdout, "ID %d\n", shmid);

  chk = shmctl(shmid, IPC_STAT, buf);
  if (chk < 0) {
    perror("show_pool_stat: fail shmctl()");
    return -1;
  }
  
  fprintf(stdout, "---\n");
  fprintf(stdout, " key  = %d %#x\n", 
      buf->shm_perm.key, buf->shm_perm.key);
  fprintf(stdout, " seq  = %d\n", buf->shm_perm.seq);
  fprintf(stdout, " mode = %#o\n", buf->shm_perm.mode);
  fprintf(stdout, " current uid/gid = %d/%d\n",
      buf->shm_perm.uid, buf->shm_perm.gid);
  fprintf(stdout, " creator uid/gid = %d/%d\n",
      buf->shm_perm.cuid, buf->shm_perm.cgid);
  fprintf(stdout, "---\n");

  fprintf(stdout, " segment size =%d %#x ( %d KB, %d MB)\n",
      buf->shm_segsz, buf->shm_segsz,
      buf->shm_segsz/1024, buf->shm_segsz/1048576); /* 1MB = 1048576 */

  fprintf(stdout, " last    pid = %d\n", buf->shm_lpid);
  fprintf(stdout, " creator pid = %d\n", buf->shm_cpid);

  fprintf(stdout, " n  attached process = %d\n", buf->shm_nattch);
#if 0
  fprintf(stdout, " cn attached process = %d\n", buf->shm_cnattach);
#endif
  fprintf(stdout, " time shmat/shmdt/change = %d/%d/%d\n",
      buf->shm_atime, buf->shm_dtime, buf->shm_ctime);

  fflush(stdout);

  return 0;
}
    

  
